import { KaCustomModal } from "@kasimirjs/embed";
export declare class FlexModalConfig {
    title: string;
    size: "sm" | "lg" | "xl" | "fullscreen";
}
export declare class FlexModal extends KaCustomModal {
    protected initScope: {};
    /**
     *
     * Example:
     * const m = new FlexModal("My Title", "<div>[[message]]</div>", [`<button ka.on.click="$fn.resolve()">Save</button>`]);
     * let result = await m.show({message: "Hello World"});
     * console.log(result.message);
     *
     * @param title
     * @param body
     * @param buttons
     * @param initScope
     */
    constructor(title: string, body: string, buttons?: string[] | null, initScope?: {});
    /**
     *
     *
     * @param scope     Optional Scope to pass to the modal
     * @param parser    Optional Callback to parse the return value before resolving the promise
     */
    show(scope?: any, parser?: (scope: any) => any): Promise<any>;
}
