var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { FlexModal } from "./flex-modal";
export class FormFlexModalFormConfig {
    constructor() {
        this.type = "text";
        this.name = null;
        this.id = null;
        this.label = null;
        this.desc = null;
        this.bind = null;
    }
}
export class FormFlexModalConfig {
    constructor() {
        this.title = "unnamed";
        this.size = "xl";
        this.forms = [];
    }
}
const html = `

    <div ka.for="let c of config.forms" class="mb-3">
        <label ka.attr.for="c.id" class="form-label">[[ c.label ]]</label>
        <input ka.if="type==='text'" type="text" class="form-control" ka.attr.id="c.id" ka.attr.aria-describedby="c.id + '-desc'">
        <textarea ka.if="type==='textarea'" type="text" class="form-control" ka.attr.id="c.id" ka.attr.aria-describedby="c.id + '-desc'"></textarea>
        <div ka.attr.id="c.id + '-desc'" class="form-text">[[ c.desc ]]</div>
    </div>
`;
export class FormFlexModal extends FlexModal {
    constructor(title, forms = []) {
        super(title, html, []);
    }
    /**
     *
     *
     * @param scope     Optional Scope to pass to the modal
     * @param parser    Optional Callback to parse the return value before resolving the promise
     */
    show(scope = {}, parser = (scope) => { return scope; }) {
        const _super = Object.create(null, {
            show: { get: () => super.show }
        });
        return __awaiter(this, void 0, void 0, function* () {
            _super.show.call(this, scope, parser);
        });
    }
}
